package rt.lanyo.game.ddz;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import rt.lanyo.game.ddz.adapter.MyAdapter;
import rt.lanyo.game.ddz.mgr.OnlineMgr;
import rt.lanyo.game.ddz.mgr.PlayerMgr;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.service.MusicService;
import rt.lanyo.game.ddz.util.G;
import rt.lanyo.game.ddz.util.J;
import rt.lanyo.game.ddz.vo.CmdVO;
import rt.lanyo.game.ddz.widget.MyDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Gallery;
import android.widget.ImageButton;
import android.widget.ImageSwitcher;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.ViewSwitcher.ViewFactory;

public class Register extends Base implements AdapterView.OnItemSelectedListener{
	public static final byte DIALOG_CHANGE_HEAD = 3;
	public static final byte DIALOG_REGISTER_FAILE = 4;
	public static final byte DIALOG_REGISTER_SUCCESS = 6;
	public static final byte DIALOG_RESET = 5;
	private Button register;
	private MyDialog registerDialog;
	
	private Button reset;
	private MyDialog resetDialog;
	
	private Gallery gallery;
	private ImageSwitcher switcher;
	private int imgPosition;
	private MyDialog changeHeadDialog;
	private MyAdapter adapter;
	private ImageButton head;
	
	private EditText accountET;
	private EditText pwdET;
	private EditText pwdConfirmET;
	private RadioButton male;
	private CheckBox remember_pwd;
	
	//注册用的线程
	private Thread registerThread;
	
	protected void create() {
		setContentView(R.layout.register);
		initWidgets();
	}

	protected void handle(Message msg) {
		switch(msg.what) {
		case DIALOG_REGISTER_SUCCESS:
			if(!MyDialog.exist(registerDialog)) return;
			View v = LayoutInflater.from(getApplicationContext()).inflate(R.layout.register_to_login, null);
			remember_pwd = (CheckBox) v.findViewById(R.id.remember_pwd);
			MyDialog.change(registerDialog, R.string.tip, v, R.string.yes, R.string.no);
			break;
		case DIALOG_REGISTER_FAILE:
			if(!MyDialog.exist(registerDialog)) return;
			MyDialog.change(registerDialog, R.string.tip, R.string.account_exist, R.string.close);
			break;
		case DIALOG_NET_ERROR:
			OnlineMgr.close(); //关掉连接
			if(!MyDialog.exist(registerDialog)) return;
			MyDialog.change(registerDialog, R.string.tip, R.string.regist_faile, R.string.sure);
			break;
		}
	}
	
	protected void deal(boolean success, CmdVO c) {
		if(CmdVO.REGISTER.equals(c.cmd)) {
			//杀掉注册线程
			killThread(registerThread);
			
			if(!MyDialog.exist(registerDialog)) return;
			
			if(!success) {
				sendMsg(DIALOG_NET_ERROR);
			} else {
				if(c.content!=null&&c.content.length()>0){
					Integer id=new Integer(c.content);
					sendMsg(id>0?DIALOG_REGISTER_SUCCESS:DIALOG_REGISTER_FAILE);
				}
			}
		}
	}
	
	private void initWidgets() {
		male = (RadioButton) findViewById(R.id.male);
		reset = (Button) findViewById(R.id.reset);
		register = (Button) findViewById(R.id.register);
		head = (ImageButton) findViewById(R.id.head);
		accountET = (EditText)findViewById(R.id.account);
		pwdET = (EditText)findViewById(R.id.pwd);
		pwdConfirmET = (EditText) findViewById(R.id.pwd_confirm);
		((RadioButton) findViewById(R.id.male)).setChecked(true);
		head.setOnClickListener(this);
	}

	public void onClick(View v) {
		super.onClick(v);
		if (v == register) {
			final Player vo = PlayerMgr.validateRegister(accountET.getText().toString(), 
					pwdET.getText().toString(),
					pwdConfirmET.getText().toString(),
					imgPosition,male.isChecked()?0:1);
			if(vo!=null) {
				View view = getLayoutInflater().inflate(R.layout.progress, null);
				((TextView) view.findViewById(R.id.progress_tv)).setText(R.string.registering);
				registerDialog = MyDialog.create(R.string.tip, view, R.string.cancel);
				
				registerThread = new Thread(new Runnable() {
					public void run() {
						register(vo);
					}
				});
				registerThread.start();
			}
		} else if(v==head) {
			showDialog(DIALOG_CHANGE_HEAD);
		} else if(v==MyDialog.getBtn(changeHeadDialog, R.string.sure)) { //"更改头像" -->> "确定"
			head.setImageResource(Info.images[imgPosition]);
			MyDialog.dismiss(changeHeadDialog);
		} else if(v==MyDialog.getBtn(changeHeadDialog, R.string.cancel)) {//"更改头像" -->> "取消"
			MyDialog.dismiss(changeHeadDialog);
		} else if(v==MyDialog.getBtn(registerDialog, R.string.sure)
				|| v==MyDialog.getBtn(registerDialog, R.string.no)
				|| v==MyDialog.getBtn(registerDialog, R.string.close)
				||v==MyDialog.getBtn(registerDialog, R.string.cancel)) {
			MyDialog.dismiss(registerDialog);
			if(v!=MyDialog.getBtn(registerDialog, R.string.no) || v!=MyDialog.getBtn(registerDialog, R.string.close)) OnlineMgr.close();
		} else if(v==MyDialog.getBtn(resetDialog, R.string.yes)) {
			reset();
		} else if(v==MyDialog.getBtn(resetDialog, R.string.no)) {
			MyDialog.dismiss(resetDialog);
		} else if(v==reset) {
			showDialog(DIALOG_RESET);
		} else if(v==MyDialog.getBtn(registerDialog, R.string.yes)) {
			MyDialog.dismiss(registerDialog);
			Login.acc = accountET.getText().toString();
			Login.pwd = pwdET.getText().toString();
			Login.isRemberPwd = remember_pwd.isChecked();
			finish();
		}
	}
	
	private void reset() {
		MyDialog.dismiss(resetDialog);
		accountET.setText(null);
		pwdET.setText(null);
		pwdConfirmET.setText(null);
		male.setChecked(true);
	}

	protected Dialog onCreateDialog(int id) {
		switch(id) {
		case DIALOG_CHANGE_HEAD:
			if(changeHeadDialog==null) {
				List<Map<Object, Object>> data = new ArrayList<Map<Object,Object>>();
				for(int i : Info.images) {
					Map<Object, Object> map = new HashMap<Object, Object>();
					map.put("id", i);
					data.add(map);
				}
				adapter = new MyAdapter(this, data, R.layout.head_item, new String[]{"id"}, new int[]{R.id.head}, null);
				View view = LayoutInflater.from(this).inflate(R.layout.gallery, null);
		    	gallery = (Gallery) view.findViewById(R.id.gallery);
		    	gallery.setAdapter(adapter); 
		    	gallery.setSelection(Info.images.length/2);
		    	gallery.setOnItemSelectedListener(this);
		    	switcher = (ImageSwitcher) view.findViewById(R.id.switcher);
		    	switcher.setFactory(new ViewFactory() {
					public View makeView() {
						ImageView view = new ImageView(Register.this);
						view.setLayoutParams(new ImageSwitcher.LayoutParams(60, 60));
						return view;
					}
				});
				changeHeadDialog = MyDialog.create(R.string.choose_head, view, R.string.sure, R.string.cancel);
			}
			return changeHeadDialog.dialog;
		case DIALOG_RESET:
			if(resetDialog==null) {
				resetDialog = MyDialog.create(R.string.tip, R.string.reset_ask, R.string.yes, R.string.no);
			}
			return resetDialog.dialog;
		}
		return super.onCreateDialog(id);
	}
	
	protected void onResume() {
		super.onResume();
		G.status = G.STATUS_REGISTER;
		G.startMusicService(MusicService.CMD_GO_ON);
		G.startMusicService(MusicService.TYPE_WELCOME, MusicService.CMD_PLAY);
	}

	protected void onStop() {
		super.onStop();
		if(G.status == G.STATUS_REGISTER) G.startMusicService(MusicService.CMD_PAUSE);
	}

	public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
		imgPosition = position;
		switcher.setImageResource(Info.images[imgPosition]);
	}

	public void onNothingSelected(AdapterView<?> parent) {}
	
	private void register(Player vo) {
		OnlineMgr.sendCmd(CmdVO.REGISTER, J.toJson(vo), this);
	}

	public void onDismiss(DialogInterface dialog) {
		super.onDismiss(dialog);
		if(dialog==MyDialog.getDialog(registerDialog)) {
			if(MyDialog.getBtn(registerDialog, R.string.cancel)!=null) {//正在登陆的弹出框 
				//杀掉注册线程
				killThread(registerThread);
			}
		}
	}
}
