package rt.lanyo.game.ddz.mgr;

import java.io.InputStream;
import java.util.List;

import rt.lanyo.game.ddz.Game;
import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.model.Anim;
import rt.lanyo.game.ddz.model.Card;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.service.MusicService;
import rt.lanyo.game.ddz.util.G;
import rt.lanyo.game.ddz.view.GameView;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.graphics.Bitmap.Config;
import android.graphics.Paint.Style;
import android.graphics.drawable.Drawable;
/**
 * 管理图片加载和画
 */
public class ImgMgr {
	/**一张牌的宽度和高度**/
	public static int cardWidth;
	public static int cardHeight;
	public static int miniCardWidth;
	public static int miniCardHeight;
	/**一副牌的宽度和高度**/
	public static int pokerWidth;
	public static int pokerHeight;
	public static int miniPokerWidth;
	public static int miniPokerHeight;
	/**炸弹效果**/
	private static Anim bomb;
	private static Bitmap x2;
	private static Bitmap[] bombImgs;
	public static boolean bombed;
	/**飞机效果**/
	private static Anim plane;
	private static Bitmap planeImg;
	private static int planeX;
	public static boolean planed;
	/**出牌错误时的提示信息**/
	public static Bitmap myxpImg;
	public static Bitmap pkdImg;
	public static Bitmap pxkdImg;
	public static Bitmap zkdImg;
	public static Bitmap zskdImg;
	/**牌**/
	public static Card[] cards;
	public static Card[] miniCards;
	public static Bitmap miniCard;
	public static Bitmap miniBackCard;
	public static Bitmap backCard;
	/**游戏背景图**/
	public static Bitmap gameBg;
	/**数字**/
	public static Bitmap bossImg;
	/**时钟**/
	public static Bitmap clock;
	public static boolean beginClock;
	public static byte time = G.CLOCK_STAY_TIME;
	private static long beginTime;
	public static boolean kuaidian;  //"快点啊，等到我花都谢了！"
	/**洗牌**/
	public static boolean cleanCards = true;  //是否要洗牌
	public static int currentX; //最前面那张牌的x
	public static int maxX; //最右边那张牌的x
	public static boolean startSound = true; //是否要开始洗牌音效
	public static int cardBeginX;// 显示用户手中的牌的开始x坐标
	public static int cardBeginY;// 显示用户手中牌的开始y坐标
	/**需不需要动画**/
	public static boolean needAnim;
	
	/**初始化图片**/
	public static void initImgs() {
		pokerWidth = cardWidth*13;
		pokerHeight = cardHeight*5;
		miniPokerWidth = miniCardWidth*13;
		miniPokerHeight = miniCardHeight*5;
		
		if(clock==null) clock = getBitmap(R.drawable.clock, cardWidth, cardWidth);
		
		if(gameBg==null) gameBg = getBitmap(R.drawable.bg1, G.winWidth, G.winHeight);
		
		if(cards==null) {
			int w = cardWidth;
			int h = cardHeight;
			cards = new Card[54];
			Bitmap map = getBitmap(
					R.drawable.poker, pokerWidth, pokerHeight);
			for (int i = 0; i < 13; i++) {
				for (int j = 0; j < 4; j++) {
					Bitmap m1 = Bitmap.createBitmap(map, i * w, j * h, w, h);
					Card c = new Card(i * 4 + j, i + 1, m1, j + 1);
					cards[i * 4 + j] = c;
				}
			}
			//大王
			Bitmap m1 = Bitmap.createBitmap(map, 0, 4 * h, w, h);
			cards[53] = new Card(53, 17, m1, 2);
			//小王
			m1 = Bitmap.createBitmap(map, w, 4 * h, w, h);
			cards[52] = new Card(52, 16, m1, 1);
		}
		
		if(miniCard==null || miniBackCard==null) {
			int w = miniCardWidth;
			int h = miniCardHeight;
			miniCard = getBitmap(
					R.drawable.poker_mini, miniPokerWidth, miniPokerHeight);
			miniBackCard = Bitmap.createBitmap(miniCard, 2* w, 4 * h, w, h);
			backCard=miniBackCard;
			
			miniCards = new Card[54];
			for (int i = 0; i < 13; i++) {
				for (int j = 0; j < 4; j++) {
					Bitmap m1 = Bitmap.createBitmap(miniCard, i * w, j * h, w, h);
					Card c = new Card(i * 4 + j, i + 1, m1, j + 1);
					miniCards[i * 4 + j] = c;
				}
			}
			//大王
			Bitmap m1 = Bitmap.createBitmap(miniCard, 0, 4 * h, w, h);
			miniCards[53] = new Card(53, 17, m1, 2);
			//小王
			m1 = Bitmap.createBitmap(miniCard, w, 4 * h, w, h);
			miniCards[52] = new Card(52, 16, m1, 1);
		}
	}
	
	private static int getCardBeginX(int size) {
		return G.cardMargin + (G.winWidth - G.cardMargin * 2 - (size-1) * G.cardStep - cardWidth) / 2;
	}
	
	/**画手牌**/
	public static void drawMyHandCards(Canvas canvas, Paint paint) {
		cardBeginX = getCardBeginX(G.me.cards.size());
		cardBeginY = G.winHeight - cardHeight - 10;
		
		int outNum=0;
		if(cleanCards) { //如果是发牌
			if(startSound) {
				cardBeginX = getCardBeginX(17);
				currentX = cardBeginX + 16 * G.cardStep;
				maxX = cardBeginX + 16 * G.cardStep;
				MusicService.playSound(Card.CLEAN_CARD);
				startSound = false;
			}
			
			//发牌的效果
			currentX -= G.cardStep/3 + 16;
			if(currentX<=cardBeginX) {
				currentX = cardBeginX;
				cleanCards = false;
				if(!G.netMode) BtnMgr.showScoreBtns(0); //叫分的按钮
			}
			synchronized (G.me.cards) {//绘制发牌时的牌
				for (int i = 0; i < G.me.cards.size(); i++) {
					Card c=G.me.cards.get(i);
					canvas.drawBitmap(c.getImg(), 
							((currentX + i*G.cardStep)>maxX)?maxX:(currentX + i*G.cardStep), 
							cardBeginY + 10, paint);
				}
			}
		} else {
			synchronized (G.me.cards) {//绘制发牌过后的牌
				for (int i = 0; i < G.me.cards.size(); i++) {
					Card c=G.me.cards.get(i);
					boolean outing=G.me.willCards.contains(c);
					if(outing)outNum++;
					int y = cardBeginY + (outing ? 0 : 10);
					canvas.drawBitmap(c.getImg(), cardBeginX + i
							* G.cardStep, y, paint);
				}
			}
		}
	}
	
	/**画最后一次出的牌**/
	public static void drawMyLastCards(Canvas canvas, Paint paint) {
		synchronized (G.me.lastCards) {//绘制当前出的牌
			if(G.me.lastCards.size()>0){
				int bx = getCardBeginX(G.me.lastCards.size());
				for (int i = 0; i < G.me.lastCards.size(); i++) {
					canvas.drawBitmap(G.me.lastCards.get(i).getImg(), 
							bx + i * G.cardStep, cardBeginY-cardHeight, paint);
				}
			}
		}
	}
	
	/**画底牌**/
	public static void drawBottomCards(Canvas canvas, Paint pt, GameView gv) {
		if(gv.bottomCards==null) return;
		int bottomBx = (G.winWidth-ImgMgr.miniCardWidth*gv.bottomCards.size())/2;
		int bottomY =5;
		//显示底牌
		for(int t=0;t<gv.bottomCards.size();t++){
			canvas.drawBitmap(gv.showBottomCard?ImgMgr.getMiniCard(gv.bottomCards.get(t)):ImgMgr.miniBackCard,bottomBx+t*ImgMgr.miniCardWidth,bottomY,pt);
		}
		
		//显示底分及翻倍
		pt.setColor(G.BOTTOM_COLOR);
		Typeface face = pt.getTypeface();
		float size = pt.getTextSize();
		int color = pt.getColor();
		if(gv.bottomScore>0){
			pt.setTypeface(G.numType);
			float ax = bottomBx - G.normalSize*3 - (size+10)*G.MULTIPLE_BIT;
			int y1 = bottomY + G.normalSize; //"底分"的Y
			int y2 = y1 + bottomY + G.normalSize; //"翻倍"的Y
			canvas.drawText("底分:", ax, y1, pt);
			canvas.drawText("翻倍:", ax, y2, pt);
			pt.setTextSize(size+10);
			pt.setColor(G.numColor);
			canvas.drawText(String.valueOf(gv.bottomScore), ax + G.normalSize*3, y1+2, pt);
			canvas.drawText(String.valueOf(gv.scoreMultiple), ax + G.normalSize*3, y2+5, pt);
		}
		pt.setTypeface(face);
		pt.setTextSize(size);
		pt.setColor(color);
	}
	
	/**画玩家的相关信息:姓名、积分、出的牌、剩下的牌**/
	public static void drawPlayersInfo(Canvas canvas, Paint pt, List<Player> players) {
		for(Player p:players){
			canvas.drawBitmap(p.lord?ImgMgr.bossImg:p.icon,p.x,p.y,pt);
			int y= p.y+p.icon.getHeight()+G.normalSize;
			//显示姓名
			if(p==G.me){
				Paint pt1=new Paint();
				pt1.setStyle(Style.FILL);
				pt1.setColor(G.ME_COLOR);
				pt1.setTextSize(G.normalSize);
				pt1.setAntiAlias(true);
				pt1.setTypeface(G.normalType);
				canvas.drawText(p.name+"("+p.title+":"+p.score+")", p.x,y, pt1);
			} else {
				pt.setColor(G.OTHER_COLOR);
				y = p.y+p.icon.getHeight()+G.normalSize;
				canvas.drawText(p.name, p.x, y, pt);
				canvas.drawText("("+p.score+")",p.x, y+G.normalSize, pt);
				
				//游戏结束，显示用户剩下的牌
				if(G.status==G.STATUS_END && p.cards.size()>0) {  //如果输了,就把剩下的牌画出来
					synchronized (p.lastCards) {
						p.lastCards.clear();
						p.lastCards.addAll(p.cards);
					}
				}

				//显示用户最后出的牌
				Typeface face = pt.getTypeface();
				float size = pt.getTextSize();
				int color = pt.getColor();
				if(p.lastCards.size()>0){
					List<Card> cs=p.lastCards;
					int cWidth = ImgMgr.cardWidth;  //图片宽度
					int cHeight = ImgMgr.cardHeight; //图片高度
					int rows = (cs.size()+ G.MAX_CARD_NUMS -1)/G.MAX_CARD_NUMS;  //一共要画多少行
					
					float beginX = p.x + size*2 + ImgMgr.backCard.getWidth() + 8;
					if(p==G.me.next) {
						int tempX = G.MAX_CARD_NUMS;
						if(rows==1) {  //如果只有一行
							tempX = cs.size();
						}
						beginX = G.winWidth-((tempX-1)*G.cardStep + cWidth + G.cardMargin + p.icon.getWidth() + size);
					}
					synchronized (cs) {
						for(int t=0;t<cs.size();t++){
							//第几行
							int row = (t+ G.MAX_CARD_NUMS)/G.MAX_CARD_NUMS -1;
							//第几个
							int bit = t%G.MAX_CARD_NUMS;
							canvas.drawBitmap(cs.get(t).getImg(), beginX+bit*G.cardStep,p.msgY+row*(cHeight/2),pt);
						}
					}
				}
				
				if((G.status==G.STATUS_LOADING || Game.exitGame )&& G.netMode) continue;
				
				//绘制余下牌的张数
				y=p.y+p.icon.getHeight()*2;
				int s = p.cards.size();
				float x = p.x+p.icon.getWidth()-size*2;
				if(p==G.me.next) {
					canvas.drawBitmap(ImgMgr.backCard,p.x+p.icon.getWidth()-size*2-ImgMgr.backCard.getWidth(),y,pt); //画卡的背面
					x+=2;
				} else {
					x = p.x - 8;
					canvas.drawBitmap(ImgMgr.backCard,p.x+size*2+2,y,pt); //画卡的背面
				}
				y+=ImgMgr.backCard.getHeight()/2+size/2+7;
				x+=2;
				pt.setTextSize(size+15);
				pt.setTypeface(G.numType);
				pt.setColor(G.numColor);
				if(s/10>0){
					canvas.drawText(String.valueOf(s/10), x, y, pt);
					canvas.drawText(String.valueOf(s%10), x + size + 5, y, pt);
				} else {
					canvas.drawText(String.valueOf(0), x, y, pt);
					canvas.drawText(String.valueOf(s), x + size + 5, y, pt);
				}
				pt.setTypeface(face);
				pt.setTextSize(size);
				pt.setColor(color);
			}
		}
	}
	
	/**获得相应大小的Bitmap**/
	public static Bitmap getBitmap(int id, int width, int height) {
		Bitmap bm = Bitmap.createBitmap(width, height, Config.ARGB_8888);
		Drawable d = G.context.getResources().getDrawable(id);
		d.setBounds(0, 0, width, height);
		Canvas c = new Canvas(bm);
		d.draw(c);
		return bm;
	}
	
	public static Bitmap getMiniCard(Card card){
		int i = card.getValue();
		int j = card.getColor();
		if(i==Card.BIG_KING){
			return miniCards[52].getImg();
		} else if(i==Card.SMALL_KING) {//小王
			return miniCards[53].getImg();
		} else {
			return miniCards[(i-1) * 4 + j-1].getImg();
		}
	}
	
	public static void drawAnims(Canvas c, Paint paint) {
		drawBomb(c, paint);
		drawPlane(c, paint);
		drawColock(c, paint);
	}
	
	/**画时钟**/
	private static void drawColock(Canvas c, Paint paint) {
		if((G.curPlayer!=G.me && !G.netMode)||((G.status==G.STATUS_LOADING || Game.exitGame )&& G.netMode)) return;
		
		if(beginClock && G.curPlayer!=null) {
			Typeface face = paint.getTypeface();
			float size = paint.getTextSize();
			int color = paint.getColor();
			paint.setColor(G.numColor);
			
			if(System.currentTimeMillis()-beginTime>=1000) {
				beginTime = System.currentTimeMillis();
				time --;
			}
			
			if(time<=0) time = 0;
			int x = G.curPlayer.msgX;
			if(G.curPlayer==G.me.next) x = G.curPlayer.x-clock.getWidth();
			int y = G.curPlayer.msgY;
			c.drawBitmap(clock, x, y, paint);
			x +=  (clock.getWidth()-size*2)/2;
			y += clock.getHeight()/2+size-2;
			paint.setTextSize(size+14);
			paint.setTypeface(G.numType);
			if(time/10>0){
				c.drawText(String.valueOf(time/10), x, y, paint);
				c.drawText(String.valueOf(time%10), x + size + 2, y, paint);
			} else {
				c.drawText(String.valueOf(0), x, y, paint);
				c.drawText(String.valueOf(time), x + size + 2, y, paint);
			}
			
			paint.setTypeface(face);
			paint.setTextSize(size);
			paint.setColor(color);
		}
	}
	
	/**画飞机**/
	private static void drawPlane(Canvas c, Paint paint) {
		if(planed) {
			if(plane==null) {
				planeX = G.winWidth/2;
				planeImg = decodeBitmap(R.drawable.plane);
				plane = new Anim(planeImg, true, 100);
			} else {
				plane.end = false;
			}
			
			plane.drawAnimation(c, paint, planeX, G.winHeight/5);
			planeX -= 14;
			if(planeX+planeImg.getWidth()<0) {
				plane.end = true;
				planeX = G.winWidth/2;
				planed = false;
			}
		}
	}
	
	/**画炸弹***/
	private static void drawBomb(Canvas c, Paint paint) {
		if(bombed) {
			if(bomb==null) {
				int width = G.winWidth/2;
				int height = G.winHeight*3/5;
				bombImgs = new Bitmap[4];
				Bitmap bombImg = getBitmap(R.drawable.bomb, width, height);
				int w = width/4;
				for(int i=0; i<4; i++) {
					bombImgs[i] = Bitmap.createBitmap(bombImg, i*w, 0, w, height);
				}
				x2 = decodeBitmap(R.drawable.x2);
				bomb = new Anim(bombImgs, false, 200);
			} else {
				bomb.end = false;
			}
			
			bomb.drawAnimation(c, paint, 
					G.winWidth/2-bombImgs[0].getWidth()/2, 
					G.winHeight/5);
			c.drawBitmap(x2, 
					G.winWidth/2+bombImgs[0].getWidth(), 
					G.winHeight*3/5, paint);
			bombed = !bomb.end;
		}
	}
	
	public static void stopClock() {
		beginClock = false;
		time = G.CLOCK_STAY_TIME;
		kuaidian = false;
	}
	
	public static void beginClock() {
		beginClock = true;
		beginTime = System.currentTimeMillis();
		time = G.CLOCK_STAY_TIME;
		kuaidian = false;
	}
	
	/**高质量图片**/
	public static Bitmap decodeBitmap(int resId) {  
	    BitmapFactory.Options opt = new BitmapFactory.Options();  
	    opt.inPreferredConfig = Bitmap.Config.ARGB_8888;  
	    opt.inPurgeable = true;  
	    opt.inInputShareable = true;  
	    InputStream is = G.context.getResources().openRawResource(resId);  
	    return BitmapFactory.decodeStream(is, null, opt);  
	}
}
