package rt.lanyo.game.ddz.service;

import java.util.HashMap;
import java.util.Map;

import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.logic.CardStyle;
import rt.lanyo.game.ddz.model.Card;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.util.G;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.os.IBinder;
import android.os.Vibrator;
/**
 * 对音乐、音效、震动的管理
 * @author MJ
 */
public class MusicService extends Service {
	public static Player lastPlayer = null; //用来判断那些复杂音效
	public static CardStyle lastStyle = null;
	public static CardStyle style = null;
	public static Player cur = null;
	
	public static final String MUSIC = "music";
	public static final String CMD = "cmd";
	private static Context context;
	
	//播放命令
	public static final byte CMD_PLAY = 0;
	public static final byte CMD_PAUSE = 1;
	public static final byte CMD_STOP = 2;
	public static final byte CMD_GO_ON = 3;
	
	//不同类型的音乐
	public static final byte TYPE_WELCOME = 0;
	public static final byte TYPE_NORMAL = 1;
	public static final byte TYPE_EXCITING = 2;
	public static final byte TYPE_WIN = 3;
	public static final byte TYPE_LOSE = 4;
	private static MediaPlayer[] musics;  //0:欢迎音乐,1:游戏正常音乐,2:游戏兴奋音乐,3:游戏结束音乐
	private static int[] musicIds = new int[]{R.raw.welcome, R.raw.normal2, R.raw.exciting, R.raw.win, R.raw.lose};
	
	public static boolean needSound; //是否需要音效
	public static boolean needMusic; //是否需要音乐
	public static boolean needVibrate; //是否需要震动
	public static Vibrator vibrator;
	
	private static Map<Integer,Integer> maleSound;
	private static Map<Integer,Integer> femaleSound;
	private static Map<Integer,Integer> specialSound;
	private static SoundPool cardSoundPool;
	public static boolean exciting = false;
	private static byte dani_index = 0;
	
	private static AudioManager audioMgr;
	
	//初始化音效
	public static void initSounds(Context ctx){
		musics = new MediaPlayer[5];
		context = ctx;
		vibrator = (Vibrator)ctx.getSystemService(Service.VIBRATOR_SERVICE);
		
		//初始化soundPool对象,第一个参数是允许有多少个声音流同时播放,第2个参数是声音类型,第三个参数是声音的品质
		cardSoundPool = new SoundPool(100,AudioManager.STREAM_MUSIC,100);
		maleSound = new HashMap<Integer,Integer>();
		femaleSound = new HashMap<Integer,Integer>();
		specialSound = new HashMap<Integer,Integer>();
		loadMaleSounds();
		loadFemaleSounds();
		loadSpecialSounds();
	}
	
	private static void loadMaleSound(int raw,int id){
		maleSound.put(id, cardSoundPool.load(context, raw, id));
	}
	
	private static void loadMaleSounds() {
		//加载"单牌"
		loadMaleSound(R.raw.m_1, 1);
		loadMaleSound(R.raw.m_2, 2);
		loadMaleSound(R.raw.m_3, 3);
		loadMaleSound(R.raw.m_4, 4);
		loadMaleSound(R.raw.m_5, 5);
		loadMaleSound(R.raw.m_6, 6);
		loadMaleSound(R.raw.m_7, 7);
		loadMaleSound(R.raw.m_8, 8);
		loadMaleSound(R.raw.m_9, 9);
		loadMaleSound(R.raw.m_10, 10);
		loadMaleSound(R.raw.m_11, 11);
		loadMaleSound(R.raw.m_12, 12);
		loadMaleSound(R.raw.m_13, 13);
		loadMaleSound(R.raw.m_14, 16);
		loadMaleSound(R.raw.m_15, 17);
		
		//加载"对子"
		loadMaleSound(R.raw.m_dui1, 18);
		loadMaleSound(R.raw.m_dui2, 19);
		loadMaleSound(R.raw.m_dui3, 20);
		loadMaleSound(R.raw.m_dui4, 21);
		loadMaleSound(R.raw.m_dui5, 22);
		loadMaleSound(R.raw.m_dui6, 23);
		loadMaleSound(R.raw.m_dui7, 24);
		loadMaleSound(R.raw.m_dui8, 25);
		loadMaleSound(R.raw.m_dui9, 26);
		loadMaleSound(R.raw.m_dui10, 27);
		loadMaleSound(R.raw.m_dui11, 28);
		loadMaleSound(R.raw.m_dui12, 29);
		loadMaleSound(R.raw.m_dui13, 30);
		
		//加载其他牌型
		loadMaleSound(R.raw.m_feiji, Card.FEI_JI);
		loadMaleSound(R.raw.m_liandui, Card.LIAN_DUI);
		loadMaleSound(R.raw.m_sandaiyi, Card.SAN_DAI_YI);
		loadMaleSound(R.raw.m_sandaiyidui, Card.SAN_DAI_YI_DUI);
		loadMaleSound(R.raw.m_sange, Card.SAN_GE);
		loadMaleSound(R.raw.m_shunzi, Card.SHUN_ZI);
		loadMaleSound(R.raw.m_sidaier, Card.SI_DAI_ER);
		loadMaleSound(R.raw.m_sidailiangdui, Card.SI_DAI_LIANG_DUI);
		loadMaleSound(R.raw.m_wangzha, Card.WANG_ZHA);
		loadMaleSound(R.raw.m_zhadan, Card.ZHA_DAN);
		
		//加载"不要"
		loadMaleSound(R.raw.m_buyao1, Card.BU_YAO1);
		loadMaleSound(R.raw.m_buyao2, Card.BU_YAO2);
		loadMaleSound(R.raw.m_buyao3, Card.BU_YAO3);
		loadMaleSound(R.raw.m_buyao4, Card.BU_YAO4);
		
		//加载"大你"
		loadMaleSound(R.raw.m_dani1, Card.DA_NI1);
		loadMaleSound(R.raw.m_dani2, Card.DA_NI2);
		loadMaleSound(R.raw.m_dani3, Card.DA_NI3);
		
		//加载其他音效
		loadMaleSound(R.raw.m_yifen, Card.YI_FEN);
		loadMaleSound(R.raw.m_erfen, Card.ER_FEN);
		loadMaleSound(R.raw.m_sanfen, Card.SAN_FEN);
		loadMaleSound(R.raw.m_bujiao, Card.BU_JIAO);
		loadMaleSound(R.raw.m_kuaidian, Card.KUAI_DIAN1);
	}
	
	private static void loadFemaleSounds() {
		//加载"单牌"
		loadFemaleSound(R.raw.f_1, 1);
		loadFemaleSound(R.raw.f_2, 2);
		loadFemaleSound(R.raw.f_3, 3);
		loadFemaleSound(R.raw.f_4, 4);
		loadFemaleSound(R.raw.f_5, 5);
		loadFemaleSound(R.raw.f_6, 6);
		loadFemaleSound(R.raw.f_7, 7);
		loadFemaleSound(R.raw.f_8, 8);
		loadFemaleSound(R.raw.f_9, 9);
		loadFemaleSound(R.raw.f_10, 10);
		loadFemaleSound(R.raw.f_11, 11);
		loadFemaleSound(R.raw.f_12, 12);
		loadFemaleSound(R.raw.f_13, 13);
		loadFemaleSound(R.raw.f_14, 16);
		loadFemaleSound(R.raw.f_15, 17);
		
		//加载"对子"
		loadFemaleSound(R.raw.f_dui1, 18);
		loadFemaleSound(R.raw.f_dui2, 19);
		loadFemaleSound(R.raw.f_dui3, 20);
		loadFemaleSound(R.raw.f_dui4, 21);
		loadFemaleSound(R.raw.f_dui5, 22);
		loadFemaleSound(R.raw.f_dui6, 23);
		loadFemaleSound(R.raw.f_dui7, 24);
		loadFemaleSound(R.raw.f_dui8, 25);
		loadFemaleSound(R.raw.f_dui9, 26);
		loadFemaleSound(R.raw.f_dui10, 27);
		loadFemaleSound(R.raw.f_dui11, 28);
		loadFemaleSound(R.raw.f_dui12, 29);
		loadFemaleSound(R.raw.f_dui13, 30);
		
		//加载其他牌型
		loadFemaleSound(R.raw.f_feiji, Card.FEI_JI);
		loadFemaleSound(R.raw.f_liandui, Card.LIAN_DUI);
		loadFemaleSound(R.raw.f_sandaiyi, Card.SAN_DAI_YI);
		loadFemaleSound(R.raw.f_sandaiyidui, Card.SAN_DAI_YI_DUI);
		loadFemaleSound(R.raw.f_sange, Card.SAN_GE);
		loadFemaleSound(R.raw.f_shunzi, Card.SHUN_ZI);
		loadFemaleSound(R.raw.f_sidaier, Card.SI_DAI_ER);
		loadFemaleSound(R.raw.f_sidailiangdui, Card.SI_DAI_LIANG_DUI);
		loadFemaleSound(R.raw.f_wangzha, Card.WANG_ZHA);
		loadFemaleSound(R.raw.f_zhadan, Card.ZHA_DAN);
		
		//加载"不要"
		loadFemaleSound(R.raw.f_buyao1, Card.BU_YAO1);
		loadFemaleSound(R.raw.f_buyao2, Card.BU_YAO2);
		loadFemaleSound(R.raw.f_buyao3, Card.BU_YAO3);
		loadFemaleSound(R.raw.f_buyao4, Card.BU_YAO4);
		
		//加载"大你"
		loadFemaleSound(R.raw.f_dani1, Card.DA_NI1);
		loadFemaleSound(R.raw.f_dani2, Card.DA_NI2);
		loadFemaleSound(R.raw.f_dani3, Card.DA_NI3);
		
		//加载其他音效
		loadFemaleSound(R.raw.f_yifen, Card.YI_FEN);
		loadFemaleSound(R.raw.f_erfen, Card.ER_FEN);
		loadFemaleSound(R.raw.f_sanfen, Card.SAN_FEN);
		loadFemaleSound(R.raw.f_bujiao, Card.BU_JIAO);
		loadFemaleSound(R.raw.f_kuaidian, Card.KUAI_DIAN1);
	}
	
	private static void loadFemaleSound(int raw,int id){
		femaleSound.put(id, cardSoundPool.load(context, raw, id));
	}
	
	private static void loadSpecialSounds() {
		loadSpecialSound(R.raw.click, Card.CLICK);
		loadSpecialSound(R.raw.sendcard, Card.SEND_CARD);
		loadSpecialSound(R.raw.cleancard, Card.CLEAN_CARD);
		loadSpecialSound(R.raw.flower, Card.FLOWER);
		loadSpecialSound(R.raw.plane, Card.PLANE);
		loadSpecialSound(R.raw.bomb, Card.BOMB);
	}
	
	private static void loadSpecialSound(int raw,int id){
		specialSound.put(id, cardSoundPool.load(context, raw, id));
	}
	
	public static void playSound(int sound){
		if(!needSound) return;
		cardSoundPool.play(specialSound.get(sound), getAudioManager().getStreamVolume(AudioManager.STREAM_MUSIC), getAudioManager().getStreamVolume(AudioManager.STREAM_MUSIC), 1, 0, 1f);
	}
	
	public static void playSound(Integer sex, int sound){
		if(!needSound) return;
		sex = sex==null?Player.MALE:sex;
		switch(sex) {
		case Player.MALE:
			cardSoundPool.play(maleSound.get(sound), getAudioManager().getStreamVolume(AudioManager.STREAM_MUSIC), getAudioManager().getStreamVolume(AudioManager.STREAM_MUSIC), 1, 0, 1f);
			break;
		case Player.FEMALE:
			cardSoundPool.play(femaleSound.get(sound), getAudioManager().getStreamVolume(AudioManager.STREAM_MUSIC), getAudioManager().getStreamVolume(AudioManager.STREAM_MUSIC), 1, 0, 1f);
			break;
		}
	}
	
	/**
	 * 播放复杂音效
	 * @param style
	 */
	private static void playComplexCardSound(Integer sex, CardStyle style) {
		if(style == CardStyle.MultiTriple||style == CardStyle.MultiTripleSwingSingle||style == CardStyle.MultiTripleSwingDouble) { //飞机
			playSound(Card.PLANE);
			playSound(sex, Card.FEI_JI);
		} else if(style == CardStyle.MultiSingle) { //顺子
			playSound(Card.FLOWER);
			playSound(sex, Card.SHUN_ZI);
		} else if(style == CardStyle.MultiDouble) { //连对
			playSound(Card.FLOWER);
			playSound(sex, Card.LIAN_DUI);
		} else if(style == CardStyle.TripleAndOne) { //3带1
			playSound(Card.SEND_CARD);
			playSound(sex, Card.SAN_DAI_YI);
		} else if(style == CardStyle.TripleAndTwo) { //3带1对
			playSound(Card.SEND_CARD);
			playSound(sex, Card.SAN_DAI_YI_DUI);
		} else if(style == CardStyle.FourAndTwo) { //4带2
			playSound(Card.SEND_CARD);
			playSound(sex, Card.SI_DAI_ER);
		}
	}
	
	public static void playCardSound() {
		if(!needSound && !needVibrate) return;
		Integer id = cur==null?1:cur.id;
		Integer lastId = lastPlayer==null?null:lastPlayer.id;
		Integer sex = cur==null?Player.MALE:cur.sex;
		
		int value = cur.willCards.get(0).getValue();
		
		if(style == CardStyle.Single) { //单牌
			playSound(Card.SEND_CARD);
			playSound(sex, value);
		} else if(style == CardStyle.Double) { //对子
			playSound(Card.SEND_CARD);
			playSound(sex, value + Card.BIG_KING);
		} else if(style == CardStyle.Triple) { //3个*
			playSound(Card.SEND_CARD);
			playSound(sex, Card.SAN_GE);
			try {
				Thread.sleep(400);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			playSound(sex, value);
		} else if(style == CardStyle.Bomb) { //炸弹
			if(needVibrate) {
				vibrator.vibrate(new long[]{100,100,100,100},-1);
			}
			playSound(Card.BOMB);
			playSound(sex, Card.ZHA_DAN);
		} else if(style == CardStyle.DoubleKing) { //王炸
			if(needVibrate) {
				vibrator.vibrate(new long[]{100,100,100,100},-1);
			}
			playSound(Card.BOMB);
			playSound(sex, Card.WANG_ZHA);
		} else {  //如果不是单牌，也不是对子,也不是三个
			if(style==lastStyle  && lastId!=null && id!=lastId) { //如果上次的牌型跟这次相同，而且自己又不是上次的出牌人
				lastStyle = style;
				playSound(sex, Card.DA_NI1 + dani_index);
				
				if(style == CardStyle.MultiTriple||style == CardStyle.MultiTripleSwingSingle||style == CardStyle.MultiTripleSwingDouble) { //飞机
					playSound(Card.PLANE);
				} else if(style == CardStyle.MultiSingle || style == CardStyle.MultiDouble) { //顺子//连对
					playSound(Card.FLOWER);
				} else if(style == CardStyle.TripleAndOne||style == CardStyle.TripleAndTwo||style == CardStyle.FourAndTwo||style == CardStyle.TripleAndTwo) { //3带1
					playSound(Card.SEND_CARD);
				}
				
				if(++dani_index>2) {
					dani_index = 0;
				}
			} else {
				dani_index = 0; //清零
				playComplexCardSound(sex, style);
			}
		}
	}
	
	public static void playMusic(int index) {
		if(musics==null) return;
		if(musics[index]!=null) return;
		stopMusic(); //这句代码在前面，可以起到释放资源的作用
		if(!needMusic) return;
		if((musics[index]==null||!musics[index].isPlaying())&&context!=null) {
			musics[index] = MediaPlayer.create(context, musicIds[index]);
			musics[index].start();
			if(index==TYPE_WIN||index==TYPE_LOSE) return;
			musics[index].setLooping(true);
		}
	}
	
	public static void pause() {
		if(musics==null) return;
		for(int i=0; i<musics.length; i++) {
			if(musics[i]!=null && musics[i].isPlaying()) musics[i].pause();
		}
	}
	
	public static void goOn() {
		if(musics==null) return;
		if(!needMusic) return;
		for(int i=0; i<musics.length; i++) {
			if(musics[i]!=null && !musics[i].isPlaying()) musics[i].start();
		}
	}
	
	public static void stopMusic() {
		if(musics==null) return;
		for(int i=0; i<musics.length; i++) {
			if(musics[i]!=null) {
				if(musics[i].isPlaying()) musics[i].release();
				musics[i] = null;
			}
		}
	}
	
	public static boolean playResultMusic(Player player) {
		if(musics==null) return false;
		if(player.id==G.me.id || (!player.lord && !G.me.lord)) {
			playMusic(TYPE_WIN);
			return true;
		} else {
			playMusic(TYPE_LOSE);
			return false;
		}
	}
	
	public static void setVoiceMode(boolean music, boolean sound, boolean vibrate) {
		if(musics==null) return;
		if(!music) pause();
		if(!needMusic && music) { //上次设置静音，现在设置有音乐
			needMusic = music;
			if(musics[TYPE_WELCOME]==null&&musics[TYPE_NORMAL]==null&&musics[TYPE_EXCITING]==null&&musics[TYPE_WIN]==null&&musics[TYPE_LOSE]==null) { //刚进入游戏状态,而且上次的配置是静音
				if(G.status==G.STATUS_ENTER||G.status==G.STATUS_BEGIN) { //游戏中
					playMusic(TYPE_NORMAL);
				} else if(G.status==G.STATUS_EXCITING) { //游戏兴奋状态
					playMusic(TYPE_EXCITING);
				} else { //其他界面
					playMusic(TYPE_WELCOME);
				}
			} else {//如果刚才有音乐在播放
				goOn();
			}
		}
		
		if(!needVibrate && vibrate) {
			vibrator.vibrate(new long[]{100,100,100,100},-1);
		}
		
		needMusic = music;
		needSound = sound;
		needVibrate = vibrate;
	}
	
	public static void setVolumn(int value) {
		getAudioManager().setStreamVolume(AudioManager.STREAM_MUSIC, value, AudioManager.FLAG_ALLOW_RINGER_MODES);
	}
	
	public static AudioManager getAudioManager() {
		if(audioMgr==null) {
			Context c = context==null?G.context:context;
			audioMgr = (AudioManager)c.getSystemService(Context.AUDIO_SERVICE);
		}
		return audioMgr;
	}
	
	public IBinder onBind(Intent arg0) {return null;}
	
	/**
	 * 对指令进行处理
	 */
	public int onStartCommand(Intent intent, int flags, int startId) {
		if(intent==null) return super.onStartCommand(intent, flags, startId);
		int index = intent.getIntExtra(MUSIC, 0);
		byte cmd = intent.getByteExtra(CMD, (byte)0);
		
		if(cmd==CMD_PLAY) {
			playMusic(index);
		} else if(cmd==CMD_PAUSE) {
			pause();
		} else if(cmd==CMD_STOP) {
			stopMusic();
		} else if(cmd==CMD_GO_ON) {
			goOn();
		} 
		return super.onStartCommand(intent, flags, startId);
	}
}
