package rt.lanyo.game.ddz.view;

import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.mgr.ImgMgr;
import rt.lanyo.game.ddz.mgr.BtnMgr;
import rt.lanyo.game.ddz.util.G;
import android.app.Activity;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.util.AttributeSet;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.SurfaceHolder.Callback;
/**
 * 游戏界面的父类
 */
public abstract class BaseView extends SurfaceView implements Callback,Runnable {
	/**这些参数用来画百叶窗特效**/
	private static final byte START = 32; //一开始正方形的宽度
	private static final byte END = 0; //最后正方形的宽度
	private byte range = START; //初始化正方形宽度
	private static final byte step = 1; //正方形缩小速度
	private static int color = Color.BLACK; //正方形颜色
	
	public Activity activity;
	public Thread thread; //刷帧线程
	private int span; //线程睡眠时间
	protected Paint paint;
	
	public boolean flag; //线程循环标记

	protected Canvas canvas;
	
	public BaseView(Context context, int span, AttributeSet set) {
		super(context, set);
		this.activity = (Activity)context;
		getHolder().addCallback(this);
		init();
	}
	
	/**变量初始化**/
	private void init() {
		//color = activity.getResources().getColor(R.color.login_solid);
		
		G.msgColor = activity.getResources().getColor(R.color.login_tv);
		G.numColor = activity.getResources().getColor(R.color.login_tv);
		G.winWidth = activity.getWindowManager().getDefaultDisplay().getWidth();
		G.winHeight = activity.getWindowManager().getDefaultDisplay().getHeight();
		ImgMgr.cardWidth = G.winWidth/13;
		ImgMgr.cardHeight = G.winHeight/6;
		ImgMgr.miniCardWidth = ImgMgr.cardWidth*3/5;
		ImgMgr.miniCardHeight = ImgMgr.cardHeight*3/5;
		G.cardStep = (G.winWidth-ImgMgr.cardWidth)/21;
		G.cardMargin = G.cardStep/2;
		G.normalSize = (int)Math.sqrt(G.winWidth*G.winHeight/1200);
		G.msgSize = G.normalSize+5;
		BtnMgr.btnWidth = ImgMgr.cardWidth*3/2;
		BtnMgr.btnHeight = BtnMgr.btnWidth*2/3;
		
		paint = new Paint();
		paint.setAntiAlias(true);//设置画笔无锯齿(如果不设置可以看到效果很差)
		paint.setStyle(Style.FILL);
		paint.setAntiAlias(true);
		paint.setTextSize(G.normalSize);
		paint.setTypeface(G.normalType);
		setKeepScreenOn(true);//设置背景常亮
	}
	
	/**和surfaceDestroyed方法一起解决按home时的问题**/
	public void surfaceCreated(SurfaceHolder holder) {
		if(thread==null||!thread.isAlive()) {       
            try {
            	flag = true;
            	thread = new Thread(this);
            	thread.start(); 
            } catch(IllegalThreadStateException e) {
            	thread.resume();      
            }   
        }  
	}

	public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {}
	
	public void surfaceDestroyed(SurfaceHolder holder) {
		flag = false;
		G.destroyThread(thread);
	}
	
	/** 百叶窗效果宽度 **/
	private void drawWindow() {
		if(range==END) return;
		
		paint.setColor(color);
		for (int i = 0; i <= (G.winWidth / START); i++) {
			for (int j = 0; j <= (G.winHeight / START); j++) {
				canvas.drawRect(i*START, j*START, i*START + range, j*START + range, paint);
			}
		}
		
		if (range > END) {
			range -= step;
			if (range < END) {
				range = END;
			}
		}
	}
	
	public void run() {
		while(flag) {
			canvas = null;
			try {
				//使用同步
				synchronized (getHolder()) {
					canvas = getHolder().lockCanvas();
					onDraw(canvas);
					drawWindow();
				}
			} finally {
				if(canvas != null) {
					getHolder().unlockCanvasAndPost(canvas);
				}
			}
			
			//睡眠
			G.sleep(span);
		}
	}
}
