package rt.lanyo.game.ddz.view;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import rt.lanyo.game.ddz.Game;
import rt.lanyo.game.ddz.Info;
import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.logic.BaseAI;
import rt.lanyo.game.ddz.logic.CardStyle;
import rt.lanyo.game.ddz.logic.IAI;
import rt.lanyo.game.ddz.mgr.BtnMgr;
import rt.lanyo.game.ddz.mgr.CardMgr;
import rt.lanyo.game.ddz.mgr.ImgMgr;
import rt.lanyo.game.ddz.mgr.MsgMgr;
import rt.lanyo.game.ddz.mgr.OnlineMgr;
import rt.lanyo.game.ddz.mgr.PlayerMgr;
import rt.lanyo.game.ddz.mgr.TaskMgr;
import rt.lanyo.game.ddz.mgr.OnlineMgr.Callback;
import rt.lanyo.game.ddz.model.Btn;
import rt.lanyo.game.ddz.model.Card;
import rt.lanyo.game.ddz.model.Msg;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.service.MusicService;
import rt.lanyo.game.ddz.util.G;
import rt.lanyo.game.ddz.util.J;
import rt.lanyo.game.ddz.util.S;
import rt.lanyo.game.ddz.vo.CmdVO;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.AttributeSet;
import android.view.MotionEvent;

public class GameView extends BaseView{
	public byte lordCount; //地主的出牌次数,用于春天的判断
	public int scoreMultiple=1;///翻倍 
	public int bottomScore=0;//底分
	public int lastBottomScore=0;
	public boolean showBottomCard=false;//是否显示底牌
	public List<Card> bottomCards;
	public List<Player> players;//所有玩家
	public CardStyle lastCardStyle;//记录最后一次出牌的牌型
	public List<Card>[] lastRets;//记录最后一次所出牌的牌型分析
	
	public IAI playerAI;
	public int tipNum=0;
	public byte testCard=0;
	private String[] maleNames;
	private String[] femaleNames;
	public int[] scores;
	
	private byte lastIndex = 22;  //这两个参数用来实现"提牌"效果,22是随便赋值的，大于手牌数就行了
	private byte index; //这两个参数用来实现"提牌"效果
	
	public boolean netMode=false;//是否网络模式
	public CardMgr cardMgr;
	public Handler handler;
	
	private byte callCount = 0; //一盘中叫分总数,一盘每人最多叫一次,因此叫3次就结束叫分
	private Player lastCallPlayer; //最后一个叫分的人
	
	public static Byte myLocation;
	public static Map<Byte, Player> netPlayers; //服务器端传来的玩家信息
	public static Map<Integer, List<Integer>> netCards; //包括底牌、玩家的牌
	public static Integer distributorId;
	public static final Integer BOTTOM_KEY = -1; 
	private static Player left;
	private static Player right;
	public static int h;
	private Game game;
	public boolean outline = false;
	public List<Card> tipCards;
	
	public GameView(Context context, AttributeSet set) {
		super(context, 100, set);
		game = (Game)activity;
		if(G.context==null) G.context = context;
		players = Collections.synchronizedList(new ArrayList<Player>());
		cardMgr = new CardMgr(this);
		playerAI = new BaseAI(this);
		handler = new Handler();
		MsgMgr.handler = new Handler();
		G.status = G.STATUS_LOADING;
		maleNames = activity.getResources().getStringArray(R.array.male_names);
		femaleNames = activity.getResources().getStringArray(R.array.female_names);
		
		//加载网络模式
		loadImage(); // 初始化牌
		h=ImgMgr.pokerHeight/5;
		netMode=G.netMode;
		if(netMode){
			game.sendMsg(Game.SHOW_READY);
			MsgMgr.readyMsgs = new HashMap<Integer, Msg>();
			loadNetPlayers();//加载网络玩家
		} else {
			G.me = PlayerMgr.find();
			scores = TaskMgr.loadScores(G.me);
			G.multiple = TaskMgr.loadMultiple(G.me.taskId);
			loadPlayers();//加载本地玩家
			beginNewGame();
		}
	}
	
	protected void onDraw(final Canvas canvas) {
		canvas.drawBitmap(ImgMgr.gameBg, 0, 0, paint);//刷屏
		
		ImgMgr.drawAnims(canvas, paint); //绘制炸弹特效 绘制飞机特效 升级图片等等
		synchronized (players) {
			ImgMgr.drawPlayersInfo(canvas, paint, players); //绘制玩家信息
		}
		BtnMgr.drawSpecialBtns(canvas, paint); //绘制特殊按钮
		MsgMgr.drawMsgs(canvas, paint); //绘制消息
		if(netMode) MsgMgr.drawReady(players, canvas, paint);
		
		if((G.status==G.STATUS_LOADING || Game.exitGame )&& netMode) return;
		
		ImgMgr.drawMyHandCards(canvas, paint); //绘制跟"我"的手牌
		ImgMgr.drawMyLastCards(canvas, paint); //绘制跟"我"最后出的牌
		ImgMgr.drawBottomCards(canvas, paint, this); //绘制底牌、底分、倍数等
		BtnMgr.drawNormalBtns(canvas, paint); //绘制普通按钮
		
		if(!netMode) {
			//催你出牌的音效:"快点啊，等到我花都谢了"
			if(G.CLOCK_STAY_TIME-ImgMgr.time>=G.GAME_WAIT_TIME && !ImgMgr.kuaidian && G.curPlayer==G.me){
				Player random = players.get(Math.random()>0.5?Player.LEFT_INDEX:Player.RIGHT_INDEX);
				MusicService.playSound(random.sex, Card.KUAI_DIAN1);
				MsgMgr.append(random, R.string.kuai_dian);
				ImgMgr.kuaidian = true;
			}
		}
		
		if(ImgMgr.time==0) {  
			if(G.status==G.STATUS_ENTER) {//"不叫"
				if(G.curPlayer==G.me) {
					notCall();
				}
			} else if(G.status==G.STATUS_BEGIN||G.status==G.STATUS_EXCITING) {
				if(G.curPlayer==G.me) {
					G.me.willCards.clear();
					if(tipCards==null) tipCards = playerAI.getTipCard(G.me, G.lastPlayer, lastCardStyle, lastRets, tipNum);
					G.me.willCards.addAll(tipCards);
					cardMgr.commitCard(G.me);
				}
			}
		}
	}
	
	private void init() { // 初始化一些变量
		ImgMgr.stopClock();
		callCount = 0;
		lastCallPlayer = null;
		if(!netMode) {//改变游戏状态
			G.status = G.STATUS_ENTER;  
		} else {
			G.status = G.STATUS_LOADING; 
			game.sendMsg(Game.START_ONLINE_GAME);
		}
		lordCount = 0; //地主出牌数清零
		ImgMgr.cleanCards = true;
		ImgMgr.startSound = true;
		MusicService.exciting = false;
		G.startMusicService(MusicService.TYPE_NORMAL, MusicService.CMD_PLAY);
		lastBottomScore = bottomScore;
		bottomScore=0;
		scoreMultiple=1;
		showBottomCard=false;
		G.lastPlayer=null;
		G.curPlayer=netMode?null:G.me;
		lastCardStyle=null;
		lastRets=null;
		
		tipCards = null;
		tipNum = 0;
		
		//复位按钮
		BtnMgr.initBtns();
		if(netMode) MsgMgr.clearReadys(players);
	}
	
	public void beginNewGame() {
		init();
		
		//网络模式，全部重新洗牌
		if(netMode){
			for(Player p:players){
				p.cleanCard();
			}
		}
		
		//非网络模式，或者牌的主人负责发牌
		if(!netMode || G.me.distributor ){
			if(G.gameMode == G.GAME_MODE_FUN){
				bottomCards = cardMgr.distributeCard3(players);
			} else {
				//初始化底牌
				if(testCard==1){
					bottomCards = cardMgr.distributeCard3(players);
					testCard = 0;
				} else {
					bottomCards=cardMgr.distributeCard(players);
				}
			}
			G.curPlayer=G.me;
			if(!netMode) ImgMgr.beginClock(); //叫分开始,计时开始
		}
		
		if(netMode){
			if(G.me.distributor){
				//把洗牌结果发送到服务器
				OnlineMgr.sendCleanCards(bottomCards, players, new Callback(){
					public void execute(boolean ret,CmdVO c) {
						G.status=G.STATUS_ENTER;
						ImgMgr.beginClock(); //叫分开始,计时开始
					}
				});
			} else { //接牌
				if(netCards!=null) {
					/**解析底牌**/
					bottomCards = new ArrayList<Card>();
					for(Integer index : netCards.get(BOTTOM_KEY)) {
						bottomCards.add(ImgMgr.cards[index]);
					}
					/**解析玩家的牌**/
					for(Player p: players) {
						for(Integer index : netCards.get(p.id)) {
							p.cards.add(ImgMgr.cards[index]);
						}
						if(p.id==distributorId) G.curPlayer=p;
					}
					netCards.clear();
					netCards = null;
					G.status=G.STATUS_ENTER;
					ImgMgr.beginClock(); //叫分开始,计时开始
				}
			}
		}
		
		if(G.curPlayer==G.me) BtnMgr.showScoreBtns(bottomScore);
	}
	
	private boolean validate(Player  vo) {
		return !(vo==null || vo.id==null || vo.iconIndex==null || vo.iconIndex<0 || vo.name==null || vo.score==null);
	}
	
	private Player loadLeft(Player  vo) {
		if(!validate(vo)) return null; 
		Integer index = S.get(vo.iconIndex);
		Bitmap img = BitmapFactory.decodeResource(getResources(), Info.images[index]);
		int height = img.getHeight();
		
		Player p = vo;
		p.computer = true;
		p.score = S.get(vo.score);
		p.name = S.get(vo.name);
		p.x = G.cardMargin;
		p.y = 5;
		p.icon = img;
		
		//设置角色的消息区域
		p.msgX = p.x+p.icon.getWidth()+G.MSG_MARGIN*2;
		p.msgY = height+20;
		return p;
	}
	
	private Player loadRight(Player  vo) {
		if(!validate(vo)) return null;
		
		Integer index = S.get(vo.iconIndex);
		Bitmap img = BitmapFactory.decodeResource(getResources(), Info.images[index]);
		int width = img.getWidth();
		int height = img.getHeight();
		
		//玩家2
		Player p = vo;
		p.computer = true;
		p.score = S.get(vo.score);
		p.name = S.get(vo.name);
		p.x = G.winWidth-G.cardMargin-width;
		p.y = 5;
		p.icon = img;
		
		//msgX要特殊处理,在MsgMgr中赋值
		p.msgY = height+20;
		return p;
	}
	
	private Player loadMe() {
		G.me.computer = false;
		G.me.title = PlayerMgr.findTitle(G.me.score);
		G.me.icon = BitmapFactory.decodeResource(getResources(), Info.images[G.me.iconIndex]);
		G.me.x = G.cardMargin;
		G.me.y = G.winHeight-h-G.me.icon.getHeight()-30;
		//加载地主图片
		ImgMgr.bossImg=BitmapFactory.decodeResource(getResources(), R.drawable.image0);
		//设置消息区域
		G.me.msgX = G.me.x+G.me.icon.getWidth()+G.MSG_MARGIN;
		G.me.msgY = G.me.y-G.me.icon.getHeight()-5;
		return G.me;
	}
	
	public void loadNetPlayers(){
		if(outline) {
			if(G.status==G.STATUS_ENTER || G.status==G.STATUS_BEGIN || G.status==G.STATUS_EXCITING) {//在游戏过程中断线
				G.me.distributor = false;
				MsgMgr.clearReadys(players);
				game.sendMsg(Game.SHOW_READY);
			}
			G.toast(R.string.outline);
			outline = false;
			G.status = G.STATUS_LOADING;
		}
		
		if(G.status==G.STATUS_ENTER || G.status==G.STATUS_BEGIN || G.status==G.STATUS_EXCITING) {//说明有人逃跑
			G.me.distributor = false;
			MsgMgr.clearReadys(players);
			synchronized (players) {
				for(Player p : players) {
					p.score = p.score+ (lastBottomScore==0?3:lastBottomScore) * scoreMultiple * 2;
				}
			}
			G.toast(R.string.double_score);
			game.sendMsg(Game.SHOW_READY);
		}
		
		G.status=G.STATUS_LOADING;
		
		for (Iterator<Player> iterator = players.iterator(); iterator.hasNext();) {
			if(iterator.next()!=G.me) iterator.remove();
		}
		
		if(!players.contains(G.me)) {
			synchronized (players) {
				players.add(loadMe());
			}
		}
		
		if(netPlayers!=null) {
			if(myLocation==Player.LEFT) {
				left = loadLeft(netPlayers.get(Player.RIGHT));
				right = loadRight(netPlayers.get(Player.BOTTOM));
			} else if(myLocation==Player.RIGHT) {
				left = loadLeft(netPlayers.get(Player.BOTTOM));
				right = loadRight(netPlayers.get(Player.LEFT));
			}  else if(myLocation==Player.BOTTOM) {
				left = loadLeft(netPlayers.get(Player.LEFT));
				right = loadRight(netPlayers.get(Player.RIGHT));
			} 
			
			synchronized (players) {
				if(left!=null && !players.contains(left)) {
					players.add(left);
				}
				if(right!=null && !players.contains(right)) {
					players.add(right);
				}
			}
			if(MsgMgr.readyMsgs!=null) MsgMgr.readyMsgs.clear();
			if(players.contains(left)) left.next = G.me;
			if(players.contains(right)) G.me.next = right;
			
			if(players.contains(left) && players.contains(right)) {
				right.next = left;
			}
		}
	}
	
	public void loadPlayers(){//加载玩家
		int icon = (int)(Math.random()*(Info.images.length/2));
		int icon2 = (int)(Math.random()*(Info.images.length/2))+5;
		
		Bitmap img1 = BitmapFactory.decodeResource(getResources(), Info.images[icon]);
		Bitmap img2 = BitmapFactory.decodeResource(getResources(), Info.images[icon2]);
		int width = img1.getWidth();
		int height = img1.getHeight();
		
		Player p1=new Player();
		p1.id = Player.LEFT_ID;
		p1.iconIndex = icon;
		p1.sex = Player.MALE;
		p1.name = maleNames[icon];
		p1.computer = true;
		p1.x = G.cardMargin;
		p1.y = 5;
		p1.score = scores[0];
		p1.icon = img1;
		
		//玩家2
		Player p2=new Player();
		p2.id = Player.RIGHT_ID;
		p2.name = femaleNames[icon2-Info.images.length/2];
		p2.computer = true;
		p2.iconIndex = icon2;
		p2.sex = Player.FEMALE;
		p2.score = scores[1]; 
		p2.x = G.winWidth-G.cardMargin-width;
		p2.y = 5;
		p2.icon = img2;
		

		//玩家3
		G.me.computer = false;
		G.me.x = G.cardMargin;
		Bitmap myImg = BitmapFactory.decodeResource(this.getResources(), Info.exist(G.me.iconIndex));
		G.me.icon = myImg;
		G.me.y = G.winHeight-h-G.me.icon.getHeight()-30;
		
		//设置顺序，p1,GameData.me,p2
		p1.next = G.me;
		G.me.next = p2;
		p2.next = p1;
		
		players.add(p1);
		players.add(p2);
		players.add(G.me);
		//加载地主图片
		ImgMgr.bossImg=BitmapFactory.decodeResource(getResources(), R.drawable.image0);
		//设置角色的消息区域
		p1.msgX = p1.x+p1.icon.getWidth()+G.MSG_MARGIN*2;
		p1.msgY = height+20;
		
		//p2的msgX要特殊处理,在MsgMgr中赋值
		p2.msgY = height+20;
		
		G.me.msgX = G.me.x+G.me.icon.getWidth()+G.MSG_MARGIN;
		G.me.msgY = G.me.y-G.me.icon.getHeight()-5;
		
		p2.position = 1;
		
		//设置由谁来发牌
		G.me.distributor = true;
	}
	
	private void loadImage() {
		ImgMgr.initImgs(); //加载一系列图片
		BtnMgr.loadBtns(); // 加载操作图标
	}
	
	public boolean onTouchEvent(MotionEvent event) {
		int action = event.getAction();
		float x = event.getX();
		float y = event.getY();
		if (action==MotionEvent.ACTION_DOWN) {
			Btn ub = BtnMgr.findBtn(x, y);
			if(ub!=null){
				MusicService.playSound(Card.CLICK);
				ub.selected=true;
				handlerButton(ub);
				return true;
			} else {
				if(netMode) {
					Player p = PlayerMgr.findPlayer(players, x, y);
					if(p!=null) {
						Game.clickPlayer = p;
						game.sendMsg(Game.DIALOG_INFO);
						return true;
					}
				}
			}
		}
		
		if(!netMode && G.status==G.STATUS_END)  return true;
		lastIndex = index;
		if(action==MotionEvent.ACTION_UP) lastIndex = 22;
		
		if(action==MotionEvent.ACTION_DOWN||action==MotionEvent.ACTION_MOVE) {
			if (x > ImgMgr.cardBeginX && x < (G.winWidth - ImgMgr.cardBeginX)
					&& y > ImgMgr.cardBeginY) {
				//叫牌还未结束，不能出牌
				if(G.status!=G.STATUS_BEGIN&&G.status!=G.STATUS_EXCITING) return true;
				index = (byte)((x - ImgMgr.cardBeginX) / G.cardStep);
				if (index >= G.me.cards.size()) index = (byte)(G.me.cards.size() - 1);
				if(event.getAction()==MotionEvent.ACTION_MOVE&&lastIndex==index) return true;//如果碰到相同的牌，将不会再起作用
				MusicService.playSound(Card.CLICK);
				Card c=G.me.cards.get(index);
				if(G.me.willCards.contains(c)){
					G.me.willCards.remove(c);
				} else {
					G.me.willCards.add(c);
				}
			}
		}
		return true;
	}
	
	public void showWinner(Player player){
		G.sleep(G.SHOW_END_CARDS_TIME); //停留N毫秒后显示胜利结果
		G.me.distributor = false; //清空变量
		G.isWin = MusicService.playResultMusic(player);
		G.status = G.STATUS_END; //修改游戏状态,表示游戏结束了
		
    	int score = bottomScore * scoreMultiple;
    	if(G.curPlayer.lord){
    		//boss加分，其它人减分
    		if(G.gameMode != G.GAME_MODE_FUN) G.curPlayer.score = score*2+G.curPlayer.score;
    		G.curPlayer.result = score*2;
    		for(Player p:players){
    			if(!p.lord){
    				if(G.gameMode != G.GAME_MODE_FUN) p.score = p.score-score;
    				p.result = score*-1;
    			}
    		}
    	} else {
    		for(Player p:players){
    			if(p.lord){
    				//减分
    				if(G.gameMode != G.GAME_MODE_FUN) p.score = p.score-score*2;
    				p.result = score*-2;
    			} else {
    				//加分
    				if(G.gameMode != G.GAME_MODE_FUN) p.score = p.score+score;
    				p.result = score;
    			}
    		}
    	}
    	
    	BtnMgr.resetHandleBtns();
    	
    	if(G.gameMode != G.GAME_MODE_FUN && !netMode) 
    	Game.levelUp = PlayerMgr.updateScore(G.me);//保存分数
    	
    	Message m = new Message();
    	Bundle b = new Bundle();
    	b.putSerializable("me", G.me);
    	for(Player p : players) {
    		if(p.next==G.me) 
    			b.putSerializable("p1", p);
    		if(G.me.next==p) 
    			b.putSerializable("p2", p);
    	}
    	m.setData(b);
    	
    	//发比分结果到服务器
    	if(netMode && G.me == player) {
    		Map<Integer, Integer> scores = new HashMap<Integer, Integer>();
    		for(Player p : players) {
    			scores.put(p.id, p.result);
        	}
    		OnlineMgr.sendCmd(CmdVO.END, J.toJson(scores));
    	}
    	
		//下面是对闯关任务的判断
		if(G.gameMode==G.GAME_MODE_TASK) {
			G.me.winner = G.me==player;
			G.me.rounds = S.get(G.me.rounds) + 1;
			G.me.taskRounds = S.get(G.me.taskRounds) + 1;
			if(!G.isWin) {
				G.me.loseRounds = S.get(G.me.loseRounds) + 1;
			}
			G.me.leftScore = players.get(Player.LEFT_INDEX).score;
			G.me.rightScore = players.get(Player.RIGHT_INDEX).score;
			G.me.lastStyle = CardMgr.getCardStyle(G.me.lastCards);
			int ret = TaskMgr.judge(G.me);
			switch(ret) {
				case TaskMgr.SUCCESS :
					G.me.taskId = S.get(G.me.taskId)+1;
					G.me.rounds = 0;
					G.me.loseRounds = 0;
					break;
				case TaskMgr.FAILED :
					G.me.rounds = 0;
					G.me.loseRounds = 0;
					break;
			}
			if(!netMode) PlayerMgr.saveOrUpdate(G.me);
			m.what = ret;
		}
		
		G.sleep(G.SHOW_SCORE_BOARD_TIME);  //等待1秒后弹出结果框
		game.sendMsg(m);
	}
	
	private void endCall() {//叫分完毕,开始打牌
		lastCallPlayer.cards.addAll(bottomCards);
		cardMgr.sortCards(lastCallPlayer.cards);
		showBottomCard = true;
		lastCallPlayer.lord = true;
		
		if (G.me == lastCallPlayer) {
			BtnMgr.showHandleBtns();
		} else {
			if(!netMode) {
				G.sleep(500);
				cardMgr.commitCard(lastCallPlayer);// 开始出牌
			}
		}
		G.status = G.STATUS_BEGIN;
		G.curPlayer = lastCallPlayer;  //设置为当前的player
		ImgMgr.beginClock(); //叫分结束,比赛开始,计时开始
	}
	
	public void callScore(int score,Player player){
		lastCallPlayer = player;
		callCount++;
		MusicService.playSound(player.sex, Card.BU_JIAO+score);
		
		MsgMgr.append(player, score+"分");
		
		if(!netMode) G.sleep(500);
		
		bottomScore=score;
		G.curPlayer=player;
		
		if(player==G.me) {
			BtnMgr.resetScoreBtns(); //更改用户按钮
			//把叫牌情况传递到服务器
			if(netMode) OnlineMgr.sendCmd(CmdVO.CALL, score, G.me.id);
		}
		
		if (bottomScore>2||(callCount>2 && lastCallPlayer!=null)) {
			endCall();
		} else {
			G.curPlayer=player.next;
			ImgMgr.beginClock(); //叫分结束,比赛开始,计时开始
			if(G.curPlayer==G.me){
				BtnMgr.showScoreBtns(bottomScore);
			} else {
				if (!netMode) willCall();
				//电脑叫牌，暂时为随机;网络模式就等待服务器发送结果
			}
		}
	}

	public void notCall() {// 不叫，自动往下叫牌
		callCount++; //叫分次数+1
		MusicService.playSound(G.curPlayer.sex, Card.BU_JIAO);
		
		MsgMgr.append(G.curPlayer, "不叫");
		if(!netMode) G.sleep(500);
		
		if (G.curPlayer == G.me) {
			BtnMgr.resetScoreBtns(); //更改用户按钮
			// 把叫牌情况发到服务器
			if(netMode) OnlineMgr.sendCmd(CmdVO.CALL, 0, G.me.id);
		}
		
		if(callCount>2) {
			if(lastCallPlayer==null) {//三个人都叫过了，而且都是不叫，就重新发牌
				beginNewGame();
				return;
			} else {//三个人都叫过了，而且最后一个人不叫，就从前面的人中挑出最高分的做地主
				endCall();
				return;
			}
		}
		
		if(G.curPlayer!=null)G.curPlayer = G.curPlayer.next;
		ImgMgr.beginClock();  //叫分计时开始
		if(G.curPlayer==G.me){
			BtnMgr.showScoreBtns(bottomScore);
		} else {
			if (!netMode) willCall();
			//电脑叫牌，暂时为随机;网络模式就等待服务器发送结果
		}
	}
	
	private void willCall(){//电脑会叫几分
		if(Math.random()>0.5){
			int s = (int)(Math.random()*3+1);//随便叫一个
			if(s<=bottomScore && bottomScore<3) s = Math.random()>0.5?(bottomScore+1):3;
			callScore(s,G.curPlayer);
		} else {
			notCall();//不叫
		}
	}
	private void bc(){
		tipNum=0;
		if(G.lastPlayer==null||G.lastPlayer==G.me) {
			BtnMgr.bcBtn.selected = false;
			G.toast(R.string.select_cards);
			return;
		}
		G.me.willCards.clear();
		cardMgr.commitCard(G.me);
	}
	private void cp(){
		tipNum=0;
		if(G.me.willCards.size()>0){
			//检查牌型
			CardStyle style=CardMgr.getCardStyle(G.me.willCards);
			if(style==null){
				//牌型不正确
				G.me.willCards.clear();
				G.toast(R.string.wrong_cards);
				BtnMgr.cpBtn.selected = false;
				return;
			}
			
			if(G.lastPlayer!=null&&G.lastPlayer!=G.me &&style!=CardStyle.DoubleKing){
				if(style==CardStyle.Bomb){
					//炸弹可以随便炸,但不能炸别人比自己大的炸弹
					if(lastCardStyle==CardStyle.Bomb){
						int v=CardMgr.getRealValue( G.me.willCards.get(3));
						int ov=CardMgr.getRealValue( G.lastPlayer.lastCards.get(3));
						if(v<=ov){
							//大小不对
							G.me.willCards.clear();
							G.toast(R.string.wrong_cards);
							BtnMgr.cpBtn.selected = false;
							return;
						}
					}
				} else {
					//判断牌型是否相符，如果不符则提示错误
					if(style!=lastCardStyle){
						G.me.willCards.clear();
						G.toast(R.string.wrong_cards);
						BtnMgr.cpBtn.selected = false;
						return;
					}
					if(G.me.willCards.size()!=G.lastPlayer.lastCards.size()){
						G.toast(R.string.wrong_cards);
						BtnMgr.cpBtn.selected = false;
						return;
					}
					//牌型相同，则进一步检查大小
					List<Card>[] rets=CardMgr.arrangeCard(G.me.willCards);
					//单牌或者顺子
					int v=0;
					int ov=0;
					if (style == CardStyle.MultiSingle || style == CardStyle.Single) {
						v=CardMgr.getRealValue(rets[0].get(0));
						ov=CardMgr.getRealValue(lastRets[0].get(0));
					} else if (style == CardStyle.Double||style==CardStyle.MultiDouble) {
						v=CardMgr.getRealValue(rets[1].get(0));
						ov=CardMgr.getRealValue(lastRets[1].get(0));
					}else if (style == CardStyle.Triple||style==CardStyle.TripleAndOne||style==CardStyle.TripleAndTwo||style==CardStyle.MultiTriple||style==CardStyle.MultiTripleSwingDouble||style==CardStyle.MultiTripleSwingSingle) {
						v=CardMgr.getRealValue(rets[2].get(0));
						ov=CardMgr.getRealValue(lastRets[2].get(0));
					}else if (style == CardStyle.FourAndTwo) {
						v=CardMgr.getRealValue(rets[3].get(0));
						ov=CardMgr.getRealValue(lastRets[3].get(0));
					} 
					if(v<=ov){
						G.me.willCards.clear();
						G.toast(R.string.wrong_cards);
						BtnMgr.cpBtn.selected = false;
						return;
					}
				}
			}
			lastCardStyle=style;
		} else {  //如果没有提牌
			BtnMgr.cpBtn.selected = false;
			G.toast(R.string.select_cards);
			return;
		}
		cardMgr.commitCard(G.me);
	}
	
	private void handlerButton(final Btn ub){
		handler.postDelayed(new Runnable() {
			public void run() {
				if(ub==BtnMgr.score1Btn){
					callScore(1,G.me);
				} else if(ub==BtnMgr.score2Btn){
					callScore(2,G.me);
				} else if(ub==BtnMgr.score3Btn){
					callScore(3,G.me);
				} else if (ub==BtnMgr.bjBtn) {
					notCall();
				} else if(ub==BtnMgr.tipBtn){
					G.me.willCards.clear();
					if(tipCards==null) tipCards=playerAI.getTipCard(G.me, G.lastPlayer, lastCardStyle, lastRets,tipNum);
					G.me.willCards.addAll(tipCards);
					if(tipCards.isEmpty()){
						if(tipNum>0){
							tipNum=0;
							tipCards=playerAI.getTipCard(G.me, G.lastPlayer, lastCardStyle, lastRets,tipNum);
						} else {
							//如果找不到大牌，则不要
							bc();
						}
					}
					else tipNum++;
					BtnMgr.tipBtn.selected = false;
				} else if(ub==BtnMgr.cpBtn){
					cp();
				} else if(ub==BtnMgr.bcBtn){ //当点击不出按钮时
					bc();
				} else if(ub==BtnMgr.qxBtn) {
					BtnMgr.qxBtn.selected = false;
					G.me.willCards.clear();
					tipNum=0;
					return;
				} else if(ub==BtnMgr.settingBtn) {
					BtnMgr.settingBtn.selected = false;
					game.sendMsg(Game.DIALOG_SETTING);
					return;
				} else if(ub==BtnMgr.taskBtn) {
					BtnMgr.taskBtn.selected = false;
					game.sendMsg(Game.DIALOG_TASK);
					return;
				}  
			}
		}, G.BTN_DELAY_TIME);
	}
}
