package rt.lanyo.game.ddz.widget;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.util.G;
import android.app.Dialog;
import android.content.DialogInterface.OnDismissListener;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

/**
 * 自定义弹出框
 */
public class MyDialog {
	public Map<Object, Button> btns;
	public Dialog dialog;
	
	/**
	 * 2个按钮的窗口(暂时写死,如果以后有更多按钮的窗口再做重构)
	 * @param t 标题
	 * @param cont 内容或id
	 * @param first 第一个按钮文字或id
	 * @param second 第二个按钮文字或id
	 */

	public static MyDialog create(Object t, Object cont, Object first, Object second) {
		return change(null, t, cont, first, second);
	}
	
	/**
	 * 1个按钮的窗口
	 */
	public static MyDialog create(Object t, Object cont, Object first) {
		return create(t, cont, first, null);
	}
	
	/**
	 * 无按钮的窗口
	 */
	public static MyDialog create(Object t, Object cont) {
		return create(t, cont, null, null);
	}
	
	/**改变窗口布局**/
	public static MyDialog change(MyDialog d,Object t, Object cont, Object first, Object second) {
		if(d==null) d = new MyDialog();
		
		LinearLayout view =  (LinearLayout) LayoutInflater.from(G.context).inflate(R.layout.dialog, null);
		String titleStr = getStr(t); //解析参数
		String firstStr = getStr(first);
		String secondStr = getStr(second);
		
		//标题
		TextView title = (TextView) view.findViewById(R.id.title);
		title.setText(titleStr);
		
		//内容
		LinearLayout contLayout = (LinearLayout) view.findViewById(R.id.cont_layout);
		TextView content = (TextView) contLayout.findViewById(R.id.cont);
		if(cont instanceof View) { //如果是自定义的内容
			contLayout.removeView(content);
			contLayout.addView((View)cont);
		} else {
			content.setText(getStr(cont));
		}
		if(first == null &&secondStr==null) { // 如果没有按钮
			d.btns = null;
			view.removeViewInLayout(view.findViewById(R.id.btns_layout));
		} else {
			//按钮
			if(d.btns==null) {
				d.btns = new HashMap<Object, Button>();
			} else {
				d.btns.clear();
			}
			Button firstBtn = (Button) view.findViewById(R.id.yes);
			if(G.context instanceof View.OnClickListener) firstBtn.setOnClickListener((View.OnClickListener)G.context);
			firstBtn.setText(firstStr);
			d.btns.put(first, firstBtn);
			if(secondStr==null) { //移除第二个按钮
				LinearLayout btnsLayout = (LinearLayout)view.findViewById(R.id.btns_layout);
				btnsLayout.removeViewInLayout(btnsLayout.findViewById(R.id.no_layout));
			} else { //设置第二个按钮的监听器
				Button secondBtn = (Button) view.findViewById(R.id.no);
				if(G.context instanceof View.OnClickListener) secondBtn.setOnClickListener((View.OnClickListener)G.context);
				secondBtn.setText(secondStr);
				d.btns.put(second, secondBtn);
			}
		}
		
		if(d.dialog==null) {
			d.dialog = new Dialog(G.context, R.style.Theme_Dialog);
			//d.dialog.setCancelable(false);
			d.dialog.show();
		}
		
		if(G.context instanceof OnDismissListener) d.dialog.setOnDismissListener((OnDismissListener)G.context);
		d.dialog.getWindow().setContentView(view);
		return d;
	}
	
	/**改变窗口布局**/
	public static MyDialog change(MyDialog d,Object t, Object cont, Object first) {
		return change(d, t, cont, first, null);
	}
	
	/**关闭窗口**/
	public static void dismiss(MyDialog d) {
		if(d!=null && d.dialog!=null && d.dialog.isShowing()) d.dialog.dismiss();
	}
	
	/**根据id获得按钮**/
	public static Button getBtn(MyDialog d, int id) {
		return d==null?null:d.btns.get(id);
	}
	
	/**如果对话框只有一个按钮**/
	public static Button getBtn(MyDialog d) {
		if(d==null) return null;
		for(Entry<Object, Button> e : d.btns.entrySet()) {
			return e.getValue();
		}
		return null;
	}
	
	public static Dialog getDialog(MyDialog d) {
		return d==null?null:d.dialog;
	}
	
	public static boolean exist(MyDialog d) {
		return !(d==null || d.dialog==null || !d.dialog.isShowing());
	}
	
	/**
	 * 解析参数
	 */
	private static String getStr(Object obj) {
		if(obj==null) return null;
		if(obj instanceof String) {
			return obj.toString();
		} else if(obj instanceof Integer){
			return G.context.getString(Integer.valueOf(obj.toString()));
		} else {
			return obj.toString();
		}
	}
}
