package rt.lanyo.game.ddz.widget;

import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.util.G;
import rt.lanyo.game.ddz.util.U;
import android.content.Context;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.widget.EditText;
/**
 * 自定义输入框
 */
public class MyET extends EditText{

	public MyET(Context context, AttributeSet attrs) {
		super(context, attrs);
		setBackgroundResource(R.drawable.edit_text); //背景
		setTextSize(TypedValue.COMPLEX_UNIT_DIP, 16); //文字大小
		setTypeface(G.normalType); //字体
		setTextColor(context.getResources().getColor(R.color.et)); //文字颜色
		setSaveEnabled(true); //可保存
		setSelectAllOnFocus(true);//聚焦时选中全部文字
//		setSingleLine(true); //单行，多了密码就明文显示了
		setHorizontallyScrolling(true);//文本超出TextView的宽度的情况下，是否出现横拉条
		setHintTextColor(context.getResources().getColor(R.color.hint_color)); //提示文字的颜色
		setHighlightColor(context.getResources().getColor(R.color.et_hl));//被选中文字的颜色
		setHeight(U.dip2px(context,35)); //高度
		setPadding(U.dip2px(context,45), 0, 0, 0); //与TextView间隔
	}
	
}
